"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.iterateFormatted = iterateFormatted;
const reactAsyncIterSpecialInfoSymbol_js_1 = require("../common/reactAsyncIterSpecialInfoSymbol.js");
const asyncIterSyncMap_js_1 = require("../common/asyncIterSyncMap.js");
const isAsyncIter_js_1 = require("../common/isAsyncIter.js");
function iterateFormatted(source, formatFn) {
    if (!(0, isAsyncIter_js_1.isAsyncIter)(source)) {
        return formatFn(source, 0);
    }
    const sourceSpecialInfo = source?.[reactAsyncIterSpecialInfoSymbol_js_1.reactAsyncIterSpecialInfoSymbol];
    return {
        [Symbol.asyncIterator]: () => (0, asyncIterSyncMap_js_1.asyncIterSyncMap)(source, formatFn)[Symbol.asyncIterator](),
        [reactAsyncIterSpecialInfoSymbol_js_1.reactAsyncIterSpecialInfoSymbol]: !sourceSpecialInfo
            ? {
                origSource: source,
                formatFn,
            }
            : {
                origSource: sourceSpecialInfo.origSource,
                formatFn: (value, i) => {
                    const prevMapResult = sourceSpecialInfo.formatFn(value, i);
                    return formatFn(prevMapResult, i);
                },
            },
    };
}
//# sourceMappingURL=index.js.map